#ifndef _BMF_H_
#define _BMF_H_

#include <SDL/SDL.h>

struct bmf_char {
	int w, h;
	int relx;
	int rely;
	int shift;
	int offset; /* x pos of beginning of the char in the whole surface */
};

struct bmf_font {
/* public: */
	int version;
	char *info;
	int charmap[256]; /* undefined chars have -1 */
/* private: */
	int line_height;
	int size_over;
	int size_under;
	int add_space;
	int size_inner;
	int colors;
	int highest_color;
	int numchars;
	struct bmf_char *chars;
		/* -1 means character is not defined, otherwise it is an index
		 * of corresponding bmf_char (e.g. use chars[charmap['A']]) */
	SDL_Surface *surface;
};

/* Returns handle to the font loaded or NULL if an error occured. */
struct bmf_font *
bmf_load(const char *fname);

/* frees the font */
void
bmf_free(struct bmf_font *f);

/* Puts a single char onto a surface. returns pointer to the structure
 * of the character printed.
 */
struct bmf_char *
bmf_putc(SDL_Surface *s, struct bmf_font *f, int x, int y, char c);

/* Puts a text onto a surface. */
void
bmf_puts(SDL_Surface *s, struct bmf_font *f, int x, int y, const char *txt);
#endif /* _BMF_H_ */
