#include "misc.h"
#include "bmf.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <SDL/SDL.h>
#include <SDL/SDL_gfxPrimitives.h>

int 
main(int argc, char *argv[])
{
    SDL_Surface *screen;
	struct bmf_font *font;
	SDL_Event event;
	char msg[1000];
	int i,j;

	if (argc < 2) {
		const char *pn = argc ? argv[0] : "bmftest";
		fprintf(stderr, "Usage: %s font_file [text]\n", pn);
		return EXIT_FAILURE;
	}

	if (argc > 2) {
		strncpy(msg, argv[2], sizeof(msg));
		for (i = 3; i < argc; i++) {
			strncat(msg, " ", sizeof(msg));
			strncat(msg, argv[3], sizeof(msg));
		}
	} else {
		strcpy(msg, "HELLO, WORLD!");
	}
	
	
    if (SDL_Init(SDL_INIT_VIDEO) < 0) {
		printf("Unable to init SDL: %s\n", SDL_GetError());
		exit(EXIT_FAILURE);
    }

    atexit(SDL_Quit);
	
    if(!(screen = SDL_SetVideoMode(800, 600, 0,
			SDL_HWSURFACE | SDL_DOUBLEBUF | SDL_FULLSCREEN))) {
		printf("Unable to set 800x600 video: %s\n", SDL_GetError());
		exit(EXIT_FAILURE);
    }

	font = bmf_load(argv[1]);

	SDL_LockSurface(screen);
	for (i = 0; i < screen->w; i++)
		for (j = 0; j < screen->h; j++)
			pixelRGBA(screen, i, j, i/2, j/2, (i+j)/4, 255);
	SDL_UnlockSurface(screen);
	bmf_puts(screen, font, 10, 100, msg);
	SDL_Flip(screen);

    while (1) {
		while (SDL_PollEvent(&event)) {
			if (event.type == SDL_QUIT) {
				SDL_Quit();
				return EXIT_SUCCESS;
			}
			if (event.type == SDL_KEYDOWN) {
				if (event.key.keysym.sym == SDLK_ESCAPE) {
					SDL_Quit();
					return EXIT_SUCCESS;
				}
			}
		}

    }
    return EXIT_SUCCESS;
}
