#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include "misc.h"

enum severity_level severity_level = sev_debug;
	
void *
xmalloc(size_t cnt)
{
	register void *x = malloc(cnt);
	if (!x) {
		perror("malloc");
		exit(EXIT_FAILURE);
	}
	return x;
}

char *
xstrdup(const char * s)
{
	register char *x = strdup(s);
	if (!x) {
		perror("malloc");
		exit(EXIT_FAILURE);
	}
	return x;
}

void
debug(enum severity_level severity, const char *system, const char *format, ...)
{
	va_list params;
	if (severity < severity_level)
		return;
	switch(severity) {
		case sev_debug: fputs("DEBUG(", stderr); break;
		case sev_warn: fputs("WARNING(", stderr); break;
		case sev_error: fputs("ERROR(", stderr); break;
		case sev_fatal: fputs("FATAL(", stderr); break;
	}
	fputs(system, stderr);
	fputs("): ", stderr);
	va_start(params, format);
	vfprintf(stderr, format, params);
	fputs("\n", stderr);
}

char *
chomp(char *s)
{
	if (!s || !*s)
		return s;
	while (*s)
		s++;
	s--;
	if (*s == '\n')
		*s = '\0';
	return s;
}
