#ifndef _MISC_H_
#define _MISC_H_

#include <stdlib.h>

enum severity_level {
	sev_debug,
	sev_warn,
	sev_error,
	sev_fatal
};

extern enum severity_level severity_level;

/* emits message if severity >= severity_level */
void
debug(enum severity_level severity, const char *system, const char *format, ...);

/* performs malloc(), exits program if failed */
void *
xmalloc(size_t cnt);

/* removes trailing \n of string s, if any. */
char *
chomp(char *s);

char *
xstrdup(const char * s);
#endif 
